﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Text;

namespace blogsample
{
    public class Comment
    {
        [Key]
        public int Id { get; set; }
        public int BlogId { get; set; }
        public string Title { get; set; }
        public DateTime Created { get; set; }
        public Blog Blog { get; set; }
    }

    public class Blog
    {
        [Key]
        public int Id { get; set; }
        public string Title { get; set; }
        public DateTime Created { get; set; }
        public ICollection<BlogCategory> BlogsCategories { get; set; }
        public ICollection<Comment> Comments { get; set; }

        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendFormat("Id: {0}\nTitle: {1}\nCreated: {2}", Id, Title, Created);
            if (Comments != null)
            {
                sb.Append("\nComments:");
                foreach (Comment c in Comments)
                {
                    sb.AppendFormat("\n\t{0}", c.Title);
                }
            }

            if (BlogsCategories != null)
            {
                sb.Append("\nCategories:");
                foreach (BlogCategory bg in BlogsCategories)
                {
                    sb.AppendFormat("\n\t{0}", bg.Category.Name);
                }
            }

            return sb.ToString();
        }
    }

    public class Category
    {
        [Key]
        public int Id { get; set; }
        public string Name { get; set; }
        public ICollection<BlogCategory> BlogsCategories { get; set; }
    }

    public class BlogCategory
    {
        public int BlogId { get; set; }
        public int CategoryId { get; set; }
        public Blog Blog { get; set; }
        public Category Category { get; set; }
    }
}
