﻿using System;
using Microsoft.EntityFrameworkCore;

namespace blogsample
{
    class Program
    {
        static void Main(string[] args)
        {
            BlogDbContext db = new BlogDbContext("local");

            if (args.Length > 0 && args[0] == "-populate")
            {
                Populate(db);
            }
            if (args.Length > 0 && args[0] == "-populatecategories")
            {
                PopulateCategories(db);
            }
            else
            {
                List(db);                   
            }            
        }

        static void Populate(BlogDbContext db)
        {
            Blog blog = new Blog
            {
                Title = "Hello World",
                Created = DateTime.Now,
                Comments = new Comment[]
                    {
                        new Comment{ Title = "Thanks!", Created = DateTime.Now },
                        new Comment{ Title = "Help", Created = DateTime.Now }
                    }
            };

            db.Blogs.Add(blog);
            db.SaveChanges();

            blog = new Blog
            {
                Title = "Hello World again!",
                Created = DateTime.Now,
                Comments = new Comment[]
                {
                        new Comment{ Title = "Thanks again!", Created = DateTime.Now },
                        new Comment{ Title = "Help again", Created = DateTime.Now }
                }
            };

            db.Blogs.Add(blog);
            db.SaveChanges();
        }

        static void PopulateCategories(BlogDbContext db)
        {
            Category sql = new Category { Name = "Sql" };
            db.Categories.Add(sql);
            var saved = db.SaveChanges();
            
            Blog blog = new Blog
            {
                Title = "Hello SQL",
                Created = DateTime.Now                
            };

            blog.BlogsCategories = new BlogCategory[]
            {
                new BlogCategory { Blog = blog, Category = sql }
            };

            db.Blogs.Add(blog);
            db.SaveChanges();
        }

        static void List(BlogDbContext db)
        {
            foreach (Blog blog in db.Blogs.Include(b => b.Comments).Include(b => b.BlogsCategories).ThenInclude(bg => bg.Category))
            {
                Console.WriteLine(blog);
                Console.WriteLine();
            }
        }
    }
}