create database BlogDb;
use BlogDb;

create table Categories
(
	Id int not null auto_increment,
    Name varchar(20) not null,
    primary key (Id) 
);

create table Blogs
(
	Id int not null auto_increment,
    Title varchar(50) not null,
    Created datetime not null,
    primary key (Id)
);

create table Comment
(
	Id int not null auto_increment,
    BlogId int not null,
    Title varchar(50) not null,
    Created datetime not null,
    primary key (Id),
    constraint FK_Comment_BlogId foreign key (BlogId) references Blogs(Id)
);

create table BlogCategory
(
	BlogId int not null,
    CategoryId int not null,
    primary key(BlogId, CategoryId),
	constraint BlogCategories_BlogId foreign key (BlogId) references Blogs(Id),
    constraint BlogsCategories_CategoryId foreign key (CategoryId) references Categories(Id)    
);

